(function ($) {
  Drupal.behaviors.conditional_message = {
    attach: function (context, settings) {
      // Shorthand for the configurations.
      var config = Drupal.settings.conditional_message;
      $.ajax({
        url: config.base_path + "conditional_message_data_output", success: function (result) {
          // Below are several checks to see if the message should be displayed.
          var check = [];
          // Check and set sessions with localStorage.
          check['session'] = true;
          var cmrs = 'conditionalMessageReadStatus';
          var readStatus = localStorage.getItem(cmrs);
          if (config.options.session && readStatus) {
            check['session'] = false;
          } else {
            localStorage.setItem(cmrs, true);
          }
          // Paths conditions.
          check['path'] = true;
          if (config.options.path && result.paths.indexOf(window.location.pathname.substr(1)) < 0) {
            check['path'] = false;
          }
          // Content type conditions.
          check['type'] = true;
          if (config.options.content_type && result.types) {
            check['type'] = false;
            result.types.forEach(function (type) {
              var typeClass = 'node-type-' + type;
              if ($('body').hasClass(typeClass)) {
                check['type'] = true;
              }
            });
          }
          // Show message if all checks pass.
          if (result.display && check['session'] && check['path'] && check['type']) {
            // Build the message HTML.
            var html = '<div class="conditional-message" style="'+
                    'background-color:#'+config.bg_colour+'; '+
                    'color:#'+config.colour+'; '+
            '">' + config.message + '<span>X</span></span></div>';
            // Place the message in the page top or bottom.
            switch (config.position) {
              case  'bottom':
                $(config.target).append($(html).addClass('conditional-message-bottom'));
                break;
                
              default:
              $(config.target).prepend($(html).addClass('conditional-message-top'));
            }
            // Close button compatible through jQuery 1.5 to 1.10+.
            if ($().on) {
              $('.conditional-message span').on('click', function () {
                $(this).parent().remove();
              });
            } else {
              $('.conditional-message span').live('click', function () {
                $(this).parent().remove();
              });
            }
          }
        }
      });
    }
  };
})(jQuery);
